<?php

 // This page pulls data dynamically from templates/php/photos.xml and transforms it with an XML stylesheet from "data/" under the same path.

?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN"
	"http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" lang="en" xml:lang="en">
<head>
<!-- 35mm Photo Viewer - client-side app -->
<!--                                     -->
<!-- v5.0.20041212: First public release -->
<!-- www.schillmania.com/projects/35mm   -->
<!--                                     -->
<title>My Photo Collection</title>
<link rel="stylesheet" type="text/css" href="style/base.css" media="all" />
<link rel="alternate stylesheet" type="text/css" href="style/base-alpha.css" title="Alpha" media="all" />
<link rel="alternate stylesheet" type="text/css" href="style/base-white.css" title="White" media="all" />
<link rel="alternate stylesheet" type="text/css" href="style/base-inverted.css" title="Inverted" media="all" />
<script type="text/javascript" src="script/addeventhandler.js"></script>
<script type="text/javascript" src="script/getelementsbyclassname.js"></script>
<script type="text/javascript" src="script/mousehandler.js"></script>
<script type="text/javascript" src="script/png.js"></script>
<script type="text/javascript" src="script/soundmanager.js"></script>
<script type="text/javascript" src="script/default.js"></script>
</head>

<body>

<div>
 <img id="photo" src="image/blank.gif" alt="" />
 <div id="caption-container">
  <div id="caption" class="png">
   <div class="shade0"></div>
   <div class="shade1"></div>
   <div class="shade2"></div>
  </div>
  <div id="bookmark"><a href="#bookmark"><img src="image/bookmark.gif" alt="&quot;Permalink&quot; to this image" /></a></div>
 </div>
</div>

<div id="container">

 <div id="controls">
  <div id="search"> </div>

  <div id="about-descriptor">
   <h2>35mm Photo Viewer 5.0b</h2>
  </div>

  <div id="photos">

<div id="photoSelector" class="photoSelector png">

 <div class="container">

 <div id="pageTabs" class="pages dark item">
  <!-- page tab items are inserted here dynamically via JS-DOM. -->
  <div class="clear"></div>
 </div>

 <!-- XML/XSLT content -->

 <?php 
  $xmlPathFromHere = "templates/php/";
  include("templates/php/data/transform.php");
 ?>

 <!-- /XML/XSLT content -->

 <div class="item alt nophotos">
  <h2 class="png" style="padding-top:6px">Notes</h2>
  <div class="content png scale">
   This is a generic container for copy and other non-image items.
   Drag this window by its title bar to move it.
  </div>
  <div class="clear png"></div>
 </div>

 <!-- end container -->

 </div>

 <!-- end photos -->

 <div id="about-content" class="item alt nophotos">
  <h2 class="png" style="padding-top:6px">Instructions</h2>
  <div class="content png scale">
    <p class="nospacing">View photos either by collection, or by keyword search. If applicable, multiple pages of photos are provided via icons under the collection tab.</p>
    <h2>About</h2>
    <p class="nospacing">Original code and images by <a href="http://www.schillmania.com/">Scott Schiller</a>. This web-based app is freely distributable for non-commercial use.</p>
    <h2>Resources</h2>
     Source: <a href="http://www.schillmania.com/projects/35mm/">35mm Photo Viewer Homepage</a><br />
     Comments? Questions? Found a bug? <a href="http://www.scottschiller.com/">Make contact</a>.
  </div>
  <div class="clear png"></div>
 </div>

</div>

<!-- end #container -->
</div>

  </div>

 </div>

<div id="photoIcons">
 <img src="image/picture.gif" alt="picture icon" />
 <img src="image/picture_1.gif" alt="picture icon - active" />
</div>

<p id="debug" class="debug"> </p>

<script type="text/javascript">preInit();</script>

</body>
</html>