<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
<xsl:output method="html" omit-xml-declaration="yes" />

  <!-- omit counting whitespace as nodes -->
  <xsl:strip-space elements="*" />

  <xsl:template name="page" match="/photos">
   <xsl:for-each select="page">
    <br /><li>
     <xsl:attribute name="id">page<xsl:value-of select="position()-1" /></xsl:attribute>
     <xsl:attribute name="class">page</xsl:attribute>
     <br />
     <!-- collection/photo -->
     <xsl:apply-templates select="." />
    </li><br />
   </xsl:for-each>
  </xsl:template>

  <xsl:template name="collection" match="/photos/page">
   <xsl:for-each select="collection">
    <br /><div>
     <xsl:choose>
      <xsl:when test="position()-1 &lt; 1">
       <xsl:attribute name="class">collection first</xsl:attribute>
      </xsl:when>
      <xsl:otherwise>
       <xsl:attribute name="class">collection</xsl:attribute>
      </xsl:otherwise>
     </xsl:choose>
     <br />
     <![CDATA[&nbsp;]]><h2 class="png">
      <xsl:value-of select="@title" />
     </h2><br />
     <![CDATA[&nbsp;]]><ul class="png scale"><br />
      <xsl:apply-templates select="." />
     <![CDATA[&nbsp;]]></ul><br />
     <![CDATA[&nbsp;]]><div class="clear png"><xsl:text> </xsl:text></div><br />
    </div><br />
   </xsl:for-each>
   <br />
  </xsl:template>

  <xsl:template match="/photos/page/collection/photo">
    <![CDATA[&nbsp;&nbsp;]]><li>
     <a title="">
      <xsl:attribute name="href">
        <xsl:value-of select="../@basehref" /><xsl:value-of select="@src" />
      </xsl:attribute>
      <xsl:attribute name="id">
       <xsl:value-of select="../@baseid" /><xsl:value-of select="position()-1" />
      </xsl:attribute>
      <xsl:if test="@default='true'">
       <xsl:attribute name="class">default</xsl:attribute>
      </xsl:if>
      <span>
       <xsl:value-of select="@text" />
      </span>
     </a>
    </li><br />
  </xsl:template>

  <xsl:template match="/photos/page/collection/video">
    <![CDATA[&nbsp;&nbsp;]]><li>
     <a title="" class="video">
      <xsl:attribute name="href">
        <xsl:value-of select="../@basehref" /><xsl:value-of select="@src" />
      </xsl:attribute>
      <xsl:attribute name="id">
       <xsl:value-of select="../@baseid" /><xsl:value-of select="position()-1" />
      </xsl:attribute>
      <span>
       <xsl:value-of select="@text" />
      </span>
     </a>
    </li><br />
  </xsl:template>

  <xsl:template match="/photos/page/collection/related">
    <![CDATA[&nbsp;&nbsp;]]><li>
     <a title="" class="related">
      <xsl:attribute name="href">
        <xsl:value-of select="@src" />
      </xsl:attribute>
      <xsl:attribute name="id">
       <xsl:value-of select="../@baseid" /><xsl:value-of select="position()-1" />
      </xsl:attribute>
      <xsl:attribute name="onclick">window.open(this.href,'externalLink');return false</xsl:attribute>
      <span>
       <xsl:value-of select="@text" />
      </span>
     </a>
    </li><br />
  </xsl:template>

  <xsl:template match="/">
   <div>
    <br />
    <br />
    <![CDATA[<!-- start -->]]>
    <br /><br />
    <ul id="pages"><br />
     <xsl:apply-templates select="/photos" />
    </ul><br />
    <br />
    <![CDATA[<!-- end -->]]><br /><br />
   </div>
  </xsl:template>

</xsl:stylesheet>
