/* Transform photos.xml with photos.xsl, display formatted results (HTML) in browser */

function formatCode(code) {
  if (!code) return 'Warning: Empty transform.';
  // return code;
  return code.replace(/&amp;nbsp;/g,'&nbsp;').replace(/</g,'&lt;').replace(/>/g,'&gt;');
}

var x = null;

function errorHandler(e) {
  x = e.toString();
  setTimeout("var o = document.createElement('div');o.innerHTML=('<p><b style=\"color:red\">There was a parsing/JS error. Invalid XML may be the source of the problem.</b><br />\"'+x+'\"</p>');document.body.appendChild(o)",1000);
}

window.onerror = errorHandler;

if (navigator.appName.indexOf('Microsoft')+1) {

  var xml = new ActiveXObject("Microsoft.XMLDOM");
  xml.async = false;
  xml.load("../photos.xml");

  var xsl = new ActiveXObject("Microsoft.XMLDOM");
  xsl.async = false;
  xsl.load("data/photo-template.xsl");

  var result = (xml.transformNode(xsl));

  window.onload = function() {
    var p = document.getElementById('code');
    p.innerHTML = formatCode(result).replace(/&lt;br\&gt;/g,'<br />');
  }

} else {

  var xsl;
  var xslt = new XSLTProcessor();   

  var xmlhttp = new XMLHttpRequest();
  xmlhttp.open("GET", "data/photo-template.xsl", false);
  xmlhttp.send(null);
 
  xsl = xmlhttp.responseXML;      
  xslt.importStylesheet(xsl);

  xmlhttp = new XMLHttpRequest();
  xmlhttp.open("GET", "photos.xml", false);
  xmlhttp.send(null);

  var xmlSource = xmlhttp.responseXML;
 
  var resultDocument = xslt.transformToDocument(xmlSource);

  window.onload = function() {
    var d = document.getElementById('temp');
    var p = document.getElementById('code');
    d.appendChild(resultDocument.getElementsByTagName('div')[0]);
    p.innerHTML = formatCode(d.getElementsByTagName('div')[0].innerHTML).replace(/&lt;br\&gt;/g,'<br />');
  }

}