<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
<xsl:output method="xhtml" omit-xml-declaration="yes" />

  <!-- omit counting whitespace as nodes -->
  <xsl:strip-space elements="*" />

  <xsl:template name="page" match="/photos">
   <xsl:for-each select="page">
    <li>
     <xsl:attribute name="id">page<xsl:value-of select="position()-1" /></xsl:attribute>
     <xsl:attribute name="class">page</xsl:attribute>
     <!-- collection/photo -->
     <xsl:apply-templates select="." />
    </li>
   </xsl:for-each>
  </xsl:template>

  <xsl:template name="collection" match="/photos/page">
   <xsl:for-each select="collection">
    <div>
     <xsl:choose>
      <xsl:when test="position()-1 &lt; 1">
       <xsl:attribute name="class">collection first</xsl:attribute>
      </xsl:when>
      <xsl:otherwise>
       <xsl:attribute name="class">collection</xsl:attribute>
      </xsl:otherwise>
     </xsl:choose>
     <h2 class="png">
      <xsl:value-of select="@title" />
     </h2>
     <ul class="png scale">
      <xsl:apply-templates select="." />
     </ul>
     <div class="clear png"><xsl:text> </xsl:text></div>
    </div>
   </xsl:for-each>
  </xsl:template>

  <xsl:template match="/photos/page/collection/photo">
    <li>
     <a title="">
      <xsl:attribute name="href">
        <xsl:value-of select="../@basehref" /><xsl:value-of select="@src" />
      </xsl:attribute>
      <xsl:attribute name="id">
       <xsl:value-of select="../@baseid" /><xsl:value-of select="position()-1" />
      </xsl:attribute>
      <xsl:if test="@default='true'">
       <xsl:attribute name="class">default</xsl:attribute>
      </xsl:if>
      <span>
       <xsl:value-of select="@text" />
      </span>
     </a>
    </li>
  </xsl:template>

  <xsl:template match="/photos/page/collection/video">
    <li>
     <a title="" class="video">
      <xsl:attribute name="href">
        <xsl:value-of select="../@basehref" /><xsl:value-of select="@src" />
      </xsl:attribute>
      <xsl:attribute name="id">
       <xsl:value-of select="../@baseid" /><xsl:value-of select="position()-1" />
      </xsl:attribute>
      <span>
       <xsl:value-of select="@text" />
      </span>
     </a>
    </li>
  </xsl:template>

  <xsl:template match="/photos/page/collection/related">
    <li>
     <a title="" class="related">
      <xsl:attribute name="href">
        <xsl:value-of select="@src" />
      </xsl:attribute>
      <xsl:attribute name="id">
       <xsl:value-of select="../@baseid" /><xsl:value-of select="position()-1" />
      </xsl:attribute>
      <xsl:attribute name="onclick">window.open(this.href,'externalLink');return false</xsl:attribute>
      <span>
       <xsl:value-of select="@text" />
      </span>
     </a>
    </li>
  </xsl:template>

  <xsl:template match="/">
   <div>
    <!-- start -->
    <ul id="pages">
     <xsl:apply-templates select="/photos" />
    </ul>
    <!-- end -->
   </div>
  </xsl:template>

</xsl:stylesheet>
